<?php
/**
 * todcm_survey_course_instruction_2.php - unit config file for TODCM Survey Course and Instruction Evaluation for teacher.
 *
 * @author $Author: suppakit $
 * @version $Id: todcm_surveycomplete_2.php,v 1.1 2011/07/20 11:07:51 suppakit Exp $
 * @copyright Copyright (c) 2011, Tiller Software Co., Ltd.
*/

require_once(CMS_TEMPLATEPATH_BUILDER . 'base/baseclass_survey.php');
if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class unit_config_data extends baseclass_survey {
	const QUESTION_1_INDEX = 1;
	const QUESTION_2_INDEX = 2;
	const QUESTION_3_INDEX = 3;
	const QUESTION_4_INDEX = 4;
	const QUESTION_5_INDEX = 5;
	const QUESTION_6_INDEX = 6;
	const QUESTION_7_INDEX = 7;
	const QUESTION_8_INDEX = 8;
	const QUESTION_9_INDEX = 9;
	const QUESTION_10_INDEX = 10;
	const QUESTION_11_INDEX = 11;
	const QUESTION_12_INDEX = 12;
	const QUESTION_13_INDEX = 13;
	const QUESTION_14_INDEX = 14;
	const QUESTION_15_INDEX = 15;
	const QUESTION_16_INDEX = 16;
	const QUESTION_17_INDEX = 17;
	const QUESTION_18_INDEX = 18;
	const QUESTION_19_INDEX = 19;
	const QUESTION_20_INDEX = 20;
	const QUESTION_21_INDEX = 21;
	const QUESTION_22_INDEX = 22;
	const QUESTION_23_INDEX = 23;
	const QUESTION_24_INDEX = 24;
	const QUESTION_25_INDEX = 25;
	const QUESTION_26_INDEX = 26;
	const QUESTION_27_INDEX = 27;
	const QUESTION_28_INDEX = 28;
	const QUESTION_29_INDEX = 29;
	const QUESTION_30_INDEX = 30;
	const QUESTION_31_INDEX = 31;

	static function get() {
		$unit_config = new stdClass();
		$unit_config->title = 'Course and Instruction Evaluation';
		$radio_text_array = array(1=>'Strongly Agree', 2=>'Agree', 3=>'Disagree', 4=>'Strongly Disagree', 5=>'Does not apply to me');
		$survey_weight = array(1=>4, 2=>3, 3=>2, 4=>1, 5=>0);
		$subtitle_style = 'text-align:left;font-size:12px;padding-bottom:1px;';

		$unit_config->stage[1] =
			array (
			'title1' => array('_type' => 'title_big_wb', '_title' => 'Course and Instruction Evaluation', '_action'=>'all'),
			'sub_title1' => array('_type' => 'title', '_title' => 'Course goals and learning targets' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_1_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_1_INDEX,
				'_question_text' => 'Course goals and learning targets are clear.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_2_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_2_INDEX,
				'_question_text' => 'The course is useful for students\' lives.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_3_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_3_INDEX,
				'_question_text' => 'The course is challenging (not to easy/not too difficult).',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title2' => array('_type' => 'title', '_title' => 'Course content' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_4_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_4_INDEX,
				'_question_text' => 'The content of this course is interesting for the students.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_5_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_5_INDEX,
				'_question_text' => 'The content is connected to students\' real life experiences.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title3' => array('_type' => 'title', '_title' => 'Course activities' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_6_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_6_INDEX,
				'_question_text' => 'Class activities are clearly connected to the course learning targets.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_7_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_7_INDEX,
				'_question_text' => 'Class activities encourage student participation.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_8_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_8_INDEX,
				'_question_text' => 'Students are given enough time to practice skills in class activities.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title4' => array('_type' => 'title', '_title' => 'Course assessment' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_9_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_9_INDEX,
				'_question_text' => 'Students are able to present what they have learned in a variety of ways (quizzes, presentations, writing, art, performances, projects, etc.)',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_10_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_10_INDEX,
				'_question_text' => 'Students are encouraged to use what they have learned in real life situations.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title5' => array('_type' => 'title', '_title' => 'Classroom Relationships' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_11_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_11_INDEX,
				'_question_text' => 'The teacher takes time to know students as unique individuals.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_12_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_12_INDEX,
				'_question_text' => 'The teacher treats each student equally regardless of ethnicity, gender, religion, proficiency (learning) level, etc.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_13_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_13_INDEX,
				'_question_text' => 'Students are encouraged to learn from their peers.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_14_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_14_INDEX,
				'_question_text' => 'Students feel they have control over what they learn and how they learn it.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title6' => array('_type' => 'title', '_title' => 'Communication' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_15_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_15_INDEX,
				'_question_text' => 'Students know what they will learn at the beginning of each class.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_16_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_16_INDEX,
				'_question_text' => 'Students feel comfortable asking questions.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_17_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_17_INDEX,
				'_question_text' => 'Students feel comfortable expressing their ideas/opinions and disagreeing with the teacher.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_18_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_18_INDEX,
				'_question_text' => 'Students can seek help from the teacher outside of class.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_19_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_19_INDEX,
				'_question_text' => 'Students are aware of how they are performing in the class.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title7' => array('_type' => 'title', '_title' => 'Organization' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_20_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_20_INDEX,
				'_question_text' => 'The teacher begins and ends class on time.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_21_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_21_INDEX,
				'_question_text' => 'The teacher is prepared for class (materials, activities, graded assignments).',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title8' => array('_type' => 'title', '_title' => 'Clarity' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_22_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_22_INDEX,
				'_question_text' => 'The teacher presents information in different ways in order to help students understand better.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_23_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_23_INDEX,
				'_question_text' => 'The teacher uses effective teaching aids (visual support, technology) to help students understanding.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_24_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_24_INDEX,
				'_question_text' => 'Students are encouraged to revise and review their work.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_25_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_25_INDEX,
				'_question_text' => 'Students are given time to reflect on what they have learned.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title9' => array('_type' => 'title', '_title' => 'Attitude' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_26_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_26_INDEX,
				'_question_text' => 'The teacher is positive and encouraging.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_27_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_27_INDEX,
				'_question_text' => 'The teacher encourages students to participate.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),

			'sub_title10' => array('_type' => 'title', '_title' => 'Evaluation/Feedback' , '_action'=>'all', '_style'=>$subtitle_style),
			self::QUESTION_28_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_28_INDEX,
				'_question_text' => 'The teacher has high, but realistic, expectations of the students.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_29_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_29_INDEX,
				'_question_text' => 'Students receive regular feedback on what they do well and how they could improve.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_30_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_30_INDEX,
				'_question_text' => 'The teacher assesses students frequently through homework, quizzes, projects, writing/speaking assignments, etc.',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			),
			self::QUESTION_31_INDEX =>
			array('_type'=>'unit_radio', '_typeid' => CMS_SURVEY_TYPE, '_action'=>'read|edit', '_index' =>self::QUESTION_31_INDEX,
				'_question_text' => 'The teacher assigns an appropriate amount of homework (not too much/not too little)',
				'_radio_text_array'=>$radio_text_array, '_survey_weight'=>$survey_weight,
			)

	);
		return $unit_config;
	}
}

?>